# -*- coding: utf-8 -*-

import random
import time


#	 a = {-2, 1, -3, 4, -1, 2, 1, -5, 4};
# maxsum = 0
	#	  for every starting position h = 0 ... a.length
	#	  		for every ending position  k = h ... a.length
	#	 *			compute sum from a[h] to a[k]
	#	  			remember the sum if it is the maximum so far 
	#	 
		
import sys
N = 1000
#generate random numbers
a = [0] * N
for i in range(N): 
    a[i] = random.randint(0, 1)
print("List generated")

#linear time version -- see https://en.wikipedia.org/wiki/Maximum_subarray_problem
t0 = time.perf_counter()
max_so_far =-sys.maxsize
for i in range(len(a)):
    sum_sub = 0
    for j in range(i,len(a)):
        sum_sub += a[j]
        if (sum_sub > max_so_far):
            max_so_far  = sum_sub
 	
print("Max subsequence sum = ", max_so_far)
print("Elapsed time (s): ",  time.perf_counter() - t0)
