# -*- coding: utf-8 -*-

import random
import time

N = 1000
#generate random numbers

a = [0] * N
for i in range(N): 
    a[i] = random.randint(0, 1)
print("List generated")


#linear time version -- see https://en.wikipedia.org/wiki/Maximum_subarray_problem
t0 = time.perf_counter()
max_so_far = max_ending_here = a[0]
for v in a[1:]:
    max_ending_here = max(v, max_ending_here + v)
    max_so_far = max(max_so_far, max_ending_here)    	
print("Max subsequence sum = ", max_so_far)
print("Elapsed time (s): ",  time.perf_counter() - t0)
